<template>
  <div class="q-pa-md">
    <q-form
      @submit="onSubmitted"
      @reset="()=>{}"
      class="q-gutter-md"
    >
      <q-input
        v-model="productForm.name"
        label="Product name *"
        hint="Enter product name"
        lazy-rules
        :rules="[ val => val && val.length > 0 || 'Please type something']"/>
      <q-input
        pattern="*(\.[0-9]{1,2})"
        numeric-keyboard-toggle
        v-model.number="productForm.price"
        :decimals="2"
        type="number"
        step="any"
        label="Product price"
        clearable
        suffix="PLN"
      />
      <q-separator/>
      <q-card-actions align="right">
        <q-btn push v-close-popup label="Submit" type="submit" color="primary"/>
      </q-card-actions>
    </q-form>
  </div>
</template>

<script>
import { productRepository } from 'src/public/ProductRepository'

export default {
  name: 'AddProductPage',
  props: {
    id: {
      type: String,
      default: null
    }
  },
  data: () => {
    return {
      productForm: {
        amount_in_basket: 0,
        name: '',
        price: 0.0
      }
    }
  },
  methods: {
    onSubmitted () {
      this.$root.$emit('on-product-submitted', this.productForm, this.id)
      this.$router.replace('/')
    }
  },
  async mounted () {
    if (this.id !== null && this.id !== undefined) {
      const product = await productRepository.getById(this.id)
      this.productForm.name = product?.name
      this.productForm.price = product?.price
      this.productForm.amount_in_basket = product?.amount_in_basket
    }
  }
}
</script>

<style scoped>

</style>
